// FINDDEMO.CPP
// This program demonstrates the use of the
// findfirst() and findnext() functions to
// display a directory listing.
#include <dir.h>
#include <iostream.h>
#include <string.h>
#include <dos.h>

void searchdirectory (char * directory )
{
  char tempdirectory[MAXPATH];
  int last_one;
  struct ffblk fileinfo;

  strcpy (tempdirectory, directory);
  // Note use of wildcard in next line; see text for details.
  strcat( tempdirectory, "*.*" );
  last_one = findfirst( tempdirectory, &fileinfo,  FA_NORMAL + FA_DIREC
						 + FA_RDONLY );
  while (!last_one) {
    if (fileinfo.ff_name[0] != '.') {
      cout << directory << fileinfo.ff_name;
      if (fileinfo.ff_attrib & FA_DIREC) {
	cout << "  <DIRECTORY>\n";
	strcpy( tempdirectory, directory );
	strcat( tempdirectory, fileinfo.ff_name );
	strcat( tempdirectory, "\\" );
	searchdirectory( tempdirectory );
      };
      cout << "\n";
   };
   last_one = findnext( &fileinfo );
  };
};

void main( void )
{

  // Set starting directory here
  searchdirectory( "C:\\" );

};
